Leia um arquivo linha por linha e se a condição for atendida continue lendo até o fim

0

Eu quero obter arquivos de data solicitados pelo usuário que estejam em dois locais diferentes e scp para outro servidor. Isto é o que tenho feito até agora, estou lutando com a leitura de constantes de arquivo e condicionamento com condição se.

  • path1 ( /nrtrdepath/ ) tem 1 arquivo
  • path2 ( /dcs/arch_05/AUDIT_REPORT/SL_AUDIT_REPORT/ ) 2 arquivos

todos os arquivos devem scp para um local

atualizado código

#=================================
#description     :This script will scp user prompted SL audit files to another SCP /tmp/SL_Audit_Report/ path .
#author          :Prabash
#date            :20170902
#================================



true > /home/cmb/SL__scripts/Prabash/list2.txt

read -p "Enter Date " n

ls -lrt /nrtrdepath/ | awk {'print $9'} | grep AuditReport_SL_nrtrde_$n.csv >> /home/cmb/SL__scripts/Prabash/list2.txt
ls -lrt /dcs/SL_AUDIT_REPORT/ | awk {'print $9'} | grep  AuditReport_SL_ICT_$n.csv.gz >> /home/cmb/SL__scripts/Prabash/list2.txt
ls -lrt /dcs/SL_AUDIT_REPORT/ | awk {'print $9'} | grep  AuditReport_SL_BI_$n.csv.gz >> /home/cmb/SL__scripts/Prabash/list2.txt

k='cat /home/cmb/SL__scripts/Prabash/list2.txt'

while IFS= read -r k ; do
if [[ $k == AuditReport_SL_nrtrde* ]] ; then
    scp /nrtrdepath/$k [email protected]:/tmp/SL_Audit_Report/
    else
    for i in $k; do scp /dcs/SL_AUDIT_REPORT/$i [email protected]:/tmp/SL_Audit_Report/
fi
done
    
por Prabash 05.09.2017 / 06:47

2 respostas

1

Parece que o que você deseja fazer é escolher três arquivos com base em uma string de data e scp em outro local. Isso pode ser feito com

#!/bin/sh

thedate="$1"

scp "/nrtrdepath/AuditReport_SL_nrtrde_$thedate.csv" \
    "/dcs/SL_AUDIT_REPORT/AuditReport_SL_ICT_$thedate.csv.gz" \
    "/dcs/SL_AUDIT_REPORT/AuditReport_SL_BI_$thedate.csv.gz" \
    [email protected]:/tmp/SL_Audit_Report/

Você executaria isso com

$ sh ./script "datestring"

onde datestring é a string que você deseja usar como data no nome do arquivo.

Isso funciona porque scp pode copiar vários arquivos para um único local, assim como cp .

Com alguma verificação de erros:

#!/bin/sh

thedate="$1"

if [ ! -f "/nrtrdepath/AuditReport_SL_nrtrde_$thedate.csv" ]; then
    printf 'AuditReport_SL_nrtrde_%s.csv is missing\n' "$thedate" >&2
    do_exit=1
fi
if [ ! -f "/dcs/SL_AUDIT_REPORT/AuditReport_SL_ICT_$thedate.csv.gz" ]; then
    printf 'AuditReport_SL_ICT_%s.csv is missing\n' "$thedate" >&2
    do_exit=1
fi
if [ ! -f "/dcs/SL_AUDIT_REPORT/AuditReport_SL_BI_$thedate.csv.gz" ]; then
    printf 'AuditReport_SL_BI_%s.csv is missing\n' "$thedate" >&2
    do_exit=1
fi

if [ "$do_exit" -eq 1 ]; then
    echo 'Some files are missing, exiting' >&2
    exit 1
fi

if ! scp "/nrtrdepath/AuditReport_SL_nrtrde_$thedate.csv" \
         "/dcs/SL_AUDIT_REPORT/AuditReport_SL_ICT_$thedate.csv.gz" \
         "/dcs/SL_AUDIT_REPORT/AuditReport_SL_BI_$thedate.csv.gz" \
         [email protected]:/tmp/SL_Audit_Report/
then
    echo 'Errors executing scp' >&2
else
    echo 'Transfer is done.'
fi
    
por 05.09.2017 / 10:37
0

Se você tiver atribuições de variáveis em um arquivo, poderá ativá-las fazendo o sourcing desse arquivo:

source /path/to/config_file
    
por 05.09.2017 / 07:10